<script setup lang="ts">
import AppButton from '@/components/ui/AppButton.vue'
import DataTable, { type DataTableColumn } from '@/components/ui/DataTable.vue'
import { client, type User, type Report } from '@/scripts/api-helper'
import { GlobalError, useAppStore } from '@/stores/app'
import { onMounted, onUnmounted, reactive } from 'vue'
import { RouterLink } from 'vue-router'

const columns: DataTableColumn[] = [
  { name: 'Sciper', field: 'sciper' },
  { name: 'Firstname', field: 'preferred_firstname' },
  { name: 'Lastname', field: 'preferred_lastname' },
  { name: 'Program', field: 'preferred_program', style: 'flex-center' },
  { name: 'Profile Picture', field: 'profile_picture_status' },
  { name: 'Form validated', field: 'form_validated', style: 'flex-center' },
  { name: 'Reports', field: 'reports' }
]

const app = useAppStore()
const state = reactive({
  rows: [] as { user: User; str: string; reports: Report[] }[],
  filteredRows: [] as User[],
  search: '',
  readyCounter: 0 as number,
  validCounter: 0 as number,
  filterPPNotReady: false,
  filterHasReports: false,
  filterRejected: false,
  reportsByUser: {} as Record<string, Report[]>
})

async function loadUsers() {
  const { error, data: users } = await client.GET('/api/admin/users', {
    params: {
      query: {
        admin_key: app.adminKey!
      }
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    state.rows = users.map((u) => ({
      user: u,
      str: `${u.sciper}${u.preferred_program}${u.preferred_firstname}${u.preferred_lastname}`.toLowerCase(),
      reports: state.reportsByUser[u.sciper] ?? []
    }))
    updateSearch()
  }
}

function updateSearch() {
  if (state.search.length > 0) {
    const q = state.search.toLowerCase()
    state.filteredRows = state.rows
      .filter(
        (u) =>
          u.str.includes(q) &&
          (!state.filterPPNotReady || u.user.profile_picture_status !== 'Ready') &&
          (!state.filterHasReports || u.reports.length > 0)
      )
      .map((u) => u.user)
  } else {
    state.filteredRows = state.rows
      .filter(
        (u) =>
          (!state.filterPPNotReady || u.user.profile_picture_status !== 'Ready') &&
          (!state.filterHasReports || u.reports.length > 0)
      )
      .map((u) => u.user)
  }
  let readyCounter = 0
  let validCounter = 0
  state.filteredRows.forEach((u) => {
    if (u.profile_picture_status === 'Ready') {
      readyCounter++
    }
    if (u.form_validated) {
      validCounter++
    }
  })
  state.readyCounter = readyCounter
  state.validCounter = validCounter
}

async function loadReports() {
  const { error, data: reports } = await client.GET('/api/admin/reports', {
    params: {
      query: {
        admin_key: app.adminKey!
      }
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    state.reportsByUser = {}
    let reportsByUser: Record<string, Report[]> = {}
    for (let r of reports) {
      if (r.user_id != null) {
        let reports = reportsByUser[r.user_id]
        if (reports != null) {
          reportsByUser[r.user_id].push(r)
        } else {
          reportsByUser[r.user_id] = [r]
        }
      }
    }
    state.reportsByUser = reportsByUser
  }
}

let intervalId = -1
onMounted(async () => {
  await loadReports()
  await loadUsers()
  intervalId = setInterval(updateSearch, 1000)
})

onUnmounted(() => {
  clearInterval(intervalId)
})
</script>

<template>
  <main id="main">
    <div class="flex justify-between">
      <h1 class="mb-5 text-2xl dark:text-white font-semibold">Users</h1>

      <RouterLink to="/admin/expected-users">
        <AppButton>Switch to expected users users</AppButton>
      </RouterLink>
    </div>

    <DataTable :columns="columns" :rows="state.filteredRows">
      <template v-slot:toolbar>
        <div
          class="flex flex-col px-4 py-3 space-y-3 lg:flex-row lg:items-center lg:justify-between lg:space-y-0 lg:space-x-4"
        >
          <div class="flex items-center flex-1 space-x-4">
            <h5>
              <span class="text-gray-500">Total: </span>
              <span class="dark:text-white">{{ state.filteredRows.length }}</span>
            </h5>
            <h5>
              <span class="text-gray-500">PP ready: </span>
              <span class="dark:text-white">{{ state.readyCounter }}</span>
            </h5>
            <h5>
              <span class="text-gray-500">Valid: </span>
              <span class="dark:text-white">{{ state.validCounter }}</span>
            </h5>
          </div>
          <div
            class="flex flex-col flex-shrink-0 space-y-3 md:flex-row md:items-center lg:justify-end md:space-y-0 md:space-x-3"
          >
            <div class="flex items-center">
              <input
                id="checkbox-reports"
                type="checkbox"
                v-model="state.filterHasReports"
                class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 rounded focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600"
              />
              <label
                for="checkbox-reports"
                class="ms-2 text-sm font-medium text-gray-400 dark:text-gray-500"
                >Has reports</label
              >
            </div>
            <div class="flex items-center">
              <input
                id="checkbox-ppnotready"
                type="checkbox"
                v-model="state.filterPPNotReady"
                class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 rounded focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600"
              />
              <label
                for="checkbox-ppnotready"
                class="ms-2 text-sm font-medium text-gray-400 dark:text-gray-500"
                >PP≠Ready</label
              >
            </div>
            <div class="flex items-center">
              <input
                id="checkbox-rejected"
                type="checkbox"
                v-model="state.filterRejected"
                class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 rounded focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600"
              />
              <label
                for="checkbox-rejected"
                class="ms-2 text-sm font-medium text-gray-400 dark:text-gray-500"
                >Rejected</label
              >
            </div>
            <input
              v-model="state.search"
              id="password"
              class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
              placeholder="Search"
            />
            <AppButton @click="loadUsers">Reload</AppButton>
          </div>
        </div>
      </template>

      <template v-slot:sciper="s">
        <RouterLink :to="`/admin/user/${s.row.sciper}`">
          <span
            :class="`cursor-pointer hover:opacity-50  text-slate-800 dark:text-slate-300 text-xs font-medium me-2 px-2.5 py-0.5 rounded ${s.row.rejected ? 'bg-red-100 dark:bg-red-900' : 'bg-slate-100 dark:bg-slate-900'}`"
          >
            {{ s.row.sciper }}
          </span>
        </RouterLink>
      </template>

      <template v-slot:preferred_program="s">
        <span
          class="bg-blue-100 text-blue-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-blue-900 dark:text-blue-300"
        >
          {{ s.row.preferred_program }}
        </span>
        <span
          v-if="s.row.preferred_program !== s.row.official_program"
          class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
        >
          {{ s.row.official_program }}
        </span>
      </template>

      <template v-slot:profile_picture_status="s">
        <span
          v-if="s.row.profile_picture_status === 'Ready'"
          class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
        >
          Ready
        </span>
        <span
          v-else
          class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
        >
          {{ s.row.profile_picture_status }}
        </span>
      </template>

      <template v-slot:form_validated="s">
        <span
          v-if="s.row.form_validated"
          class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
        >
          Yes
        </span>
        <span
          v-else
          class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
        >
          No
        </span>
      </template>

      <template v-slot:reports="s">
        <span
          v-if="!state.reportsByUser[s.row.sciper]"
          class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
        >
          No report
        </span>
        <span
          v-else
          class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
        >
          {{ state.reportsByUser[s.row.sciper].length }} reports
        </span>
      </template>
    </DataTable>
  </main>
</template>
